Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0000208Core InformActionspublic2010-07-18 14:412010-10-28 00:30
ReporterAndreas 
Assigned Tograham 
PrioritynormalSeveritymildReproducibilityalways
StatusclosedResolutionfixed 
Platformx86OSWindowsOS VersionXP
Product Version6E72 
Target VersionFixed in Version6F95 
Summary0000208: "Throwing it at" and "putting it on" both claim the syntax "drop [something] on/onto [something]"
DescriptionWhen checking out the "Throwing it at" action, the section "Typed commands leading to this action" does not list:
"throw [something preferably held] at/against/on/onto [something]"

It just lists:
"drop [something preferably held] at/against/on/onto [something]"

If you unlist this (by using "Understand "drop" as something new.") a new line has magically appeared, saying:
"discard [something preferably held] at/against/on/onto [something]"

Only if you unlist this command as well, will it magically say:
"throw [something preferably held] at/against/on/onto [something]"

This presumed bug means that Inform will understand "drop doll on shelf" or "discard doll onto shelf" as "throw doll on shelf" and report back "Futile.".

This bug existed in release 5Z71 as well.

Minimal Source Text To Reproduce
The testroom is a room.
The player carries a doll.
The shelf is a supporter in testroom.

test me with "drop doll on shelf / take doll / discard doll onto shelf"
TagsNo tags attached.
Effect(serious/mild) Game compiles but misbehaves
Attached Files

- Relationships

-  Notes
(0000310)
jmcgrew (administrator)
2010-07-18 16:41

"Throw", "discard", and "drop" are all synonymous by default, so "drop doll on shelf" is indeed parsed the same as "throw doll on shelf". This is by design.

Can you clarify what the buggy behavior is that you're reporting?
(0000312)
Andreas (reporter)
2010-07-18 17:56

If it's by design, then why does it override the "Putting it on" command "drop [other things] on/onto [something]"?

...and english might not be my native language, by I've never heard of someone throwing something being called "dropping it", especially not "dropping it AT/AGAINST" something.

...and it seems strange that if I unlist one line, another just pops up out of nowhere. Shouldn't all these three lines be visible under "Typed commands leading to this action" to begin with?
(0000314)
jmcgrew (administrator)
2010-07-18 22:30

OK, good point. I didn't realize "drop [something] on [something]" was also defined as putting it on. In fact the Actions index lists both:

"drop [something preferably held] at/against/on/onto [something]" - Throwing it at
"drop [other things] on/onto [something]" - Putting it on
(0000318)
Andreas (reporter)
2010-07-19 08:13

(You see, my suspicion is that this innocent looking overlap, hides a more serious bug in how Inform handles the line "Understand the commands "throw" and "discard" as "drop"" (in the standard rules Actions file), meaning that this bug might be one of many, many other undiscovered overlaps and magically appearing rows.)
(0000320)
Andreas (reporter)
2010-07-19 09:02

Remembering a review where the reviewer struggled with a "guess the verb" puzzle ("ATTACH is the verb I wanted. Thank you, ATTACH. How’ve you been? Oh, TIE’s been taking a lot of your gigs? Sorry to hear that.") I checked out the "tying it to" action, and found that unlisting the "tie" command, replaces the line with "fasten", and unlisting "fasten" as well, replaces it with "attach".
This means that Inform at least fails to list all synonymous phrases. At worst, this bug might be responsible for a large part of all guess-the-verb puzzles.
(0000321)
jmcgrew (administrator)
2010-07-19 09:20

I think the "magically appearing rows" are just a consequence of how Inform writes the index. "Drop", "discard", and "throw" are defined as synonyms, and instead of listing all of them (repeating each grammar line three times), Inform only lists one synonym. When you say "Understand 'drop' as something new", "drop" is no longer one of those synonyms, so Inform picks a different one to list.
(0000325)
curiousdannii (developer)
2010-07-19 17:27

Then it should say

"drop/discard/throw [something preferably held] at/against/on/onto [something]"
(0000326)
jmcgrew (administrator)
2010-07-19 17:30

Maybe. That's a feature request, though.
(0000518)
graham (administrator)
2010-09-04 15:46

Suggestions that the Actions index be improved are really suggestions, not bugs.

But the other point here is reasonable. I've altered the Standard Rules to read

Understand "drop [something preferably held] at/against [something]" as throwing it at.

rather than

Understand "drop [something preferably held] at/against/on/onto [something]" as throwing it at.

This seems more natural, and avoids the clash.

As to how THROW being equivalent to DROP came about, I think this may partly reflect a slightly more American than English usage, but possibly it relates to the command THROW AXE for getting rid of troublesome dwarves in the original Crowther and Woods adventure? At any rate, it's a traditional convention of IF.

- Issue History
Date Modified Username Field Change
2010-07-18 14:41 Andreas New Issue
2010-07-18 16:41 jmcgrew Status new => feedback
2010-07-18 16:41 jmcgrew Product Version => 6E72
2010-07-18 16:41 jmcgrew Description Updated View Revisions
2010-07-18 16:41 jmcgrew Steps to Reproduce Updated View Revisions
2010-07-18 16:41 jmcgrew Additional Information Updated View Revisions
2010-07-18 16:41 jmcgrew Note Added: 0000310
2010-07-18 16:41 jmcgrew Additional Information Updated View Revisions
2010-07-18 17:56 Andreas Note Added: 0000312
2010-07-18 17:56 Andreas Status feedback => new
2010-07-18 22:30 jmcgrew Note Added: 0000314
2010-07-18 22:33 jmcgrew Status new => confirmed
2010-07-18 22:33 jmcgrew Summary The throwing action blocks dropping and discarding commands. => "Throwing it at" and "putting it on" both claim the syntax "drop [something] on/onto [something]"
2010-07-19 08:13 Andreas Note Added: 0000318
2010-07-19 09:02 Andreas Note Added: 0000320
2010-07-19 09:20 jmcgrew Note Added: 0000321
2010-07-19 17:27 curiousdannii Note Added: 0000325
2010-07-19 17:30 jmcgrew Note Added: 0000326
2010-09-04 15:46 graham Note Added: 0000518
2010-09-04 15:46 graham Status confirmed => resolved
2010-09-04 15:46 graham Resolution open => fixed
2010-09-04 15:46 graham Assigned To => graham
2010-10-25 21:14 jmcgrew Fixed in Version => 6F95
2010-10-28 00:30 jmcgrew Status resolved => closed


Copyright © 2000 - 2010 MantisBT Group
Powered by Mantis Bugtracker